x3d equ 0
y3d equ 2
z3d equ 4
vec_x equ 0
vec_y equ 4
vec_z equ 8
; Big thanks to Mikolaj Feliks, great demos creator.
; 3d point - triple integer word coordinate
; vector   - triple float dword coordinate
;----------------------in: --------------------------------
;------------------------ esi - pointer to 1st 3d point ---
;------------------------ edi - pointer to 2nd 3d point ---
;------------------------ ebx - pointer to result vector --
;---------------------- out : none ------------------------

make_vector_r:
     movups  xmm0,[edi]
     movups  xmm1,[esi]
     subps   xmm0,xmm1
     movlps  [ebx],xmm0
     movhlps xmm1,xmm0
     movss   [ebx+8],xmm1
ret
;---------------------- in: -------------------------------
;--------------------------- esi - pointer to 1st vector --
;--------------------------- edi - pointer to 2nd vector --
;--------------------------- ebx - pointer to result vector
;---------------------- out : none
cross_product:
	fninit
	fld	dword [esi+vec_y]
	fmul	dword [edi+vec_z]
	fld	dword [esi+vec_z]
	fmul	dword [edi+vec_y]
	fsubp	;st1 ,st
	fstp	dword [ebx+vec_x]

	fld	dword [esi+vec_z]
	fmul	dword [edi+vec_x]
	fld	dword [esi+vec_x]
	fmul	dword [edi+vec_z]
	fsubp	;st1 ,st
	fstp	dword [ebx+vec_y]

	fld	dword [esi+vec_x]
	fmul	dword [edi+vec_y]
	fld	dword [esi+vec_y]
	fmul	dword [edi+vec_x]
	fsubp	;st1 ,st
	fstp	dword [ebx+vec_z]
ret
;----------------------- in: ------------------------------
;---------------------------- edi - pointer to vector -----
;----------------------- out : none
normalize_vector:
      movups  xmm0,[edi]
      movups  xmm1,[edi]
      mulps   xmm0,xmm0
      andps   xmm0,[mask_h_zero]
      haddps  xmm0,xmm0
      haddps  xmm0,xmm0
      rsqrtps  xmm0,xmm0
      mulps   xmm1,xmm0
      movlps  [edi],xmm1
      movhlps xmm0,xmm1
      movss   [edi+8],xmm0

ret
