; Line drawing procedure by Pablo Reda.
; Some changes by Maciej Guba.
;******************************************* 
lineaa:  ; eax=x1 ebx=y1 ecx=x2 edx=y2
            ; mm1  - screen buffer
            ; mm2  - screen width
            ; mm3  - color 0x00rrggbb


        cmp ebx,edx
        je horizontal 
        jg .noswap 
        xchg eax,ecx 
        xchg ebx,edx 
.noswap: 
        shl eax,16 
        shl ecx,16 
        sub eax,ecx 
        push ebx 
        push edx 
        sub ebx,edx 
        add ebx,1 
        cdq 
        idiv ebx 
        mov esi,eax 
        add ecx,$7fff 
        pop ebx 
        pop edx 
.lineas: 
        mov eax,ecx 
        add eax,esi 
        push ebx 
        push eax 
        shr ecx,16 
        shr eax,16 
        call horizontal 
        pop ecx 
        pop ebx 
        add ebx,1 
        cmp ebx,edx 
        jle .lineas
        ret

horizontal:  ; eax=x1 ebx=y1 ecx=x2 
        cmp ecx,eax 
        jg .m 
        xchg ecx,eax 
.m: 
        sub ecx,eax 
        jnz .nn
        add ecx,1 
.nn:
        push edx
        movd  edx,mm2
        imul ebx,edx    ; mm2 - screen_width_var
        pop  edx
        add eax,ebx
        movd  edi,mm1   ; mm1 - line_buffer_var
        lea edi,[edi+eax*4]
.l:
        movd [edi],mm3  ; mm3 - color
        add edi,4
        sub ecx,1
        jnz .l
        ret
